﻿
namespace IPA.AntiMalware
{
    /// <summary>
    /// The result of an Anti-Malware scan.
    /// </summary>
    public enum ScanResult
    {
        /// <summary>
        /// The object is known to be safe.
        /// </summary>
        KnownSafe,
        /// <summary>
        /// No malware was detected, but it is not known to be safe.
        /// </summary>
        NotDetected,
        /// <summary>
        /// Malware was detected, and the content should not be executed.
        /// </summary>
        Detected,
        /// <summary>
        /// The malware engine returned a threat level less than the max, so this object may be dangerous.
        /// Proceed with caution.
        /// </summary>
        MaybeMalware
    }
}
